/**
  Numarul total de biti ai unui numar natural

    Numarul Iteratii (biti)
      n         0
      n / 2     1
      n / 2^2   2
      n / 2^3   3
      ...
      n / 2^k   k


      n / 2^k = 1  => 2^k = n

      log2(2^k) = log2(n)
      k * log2(2) log2(n)
      k = log2(n)

      k = int(log2(n)) + 1  - Raspunsul exact

==================================================
Numarul de cifre in baza 7

    Numarul Iteratii (biti)
      n         0
      n / 7     1
      n / 7^2   2
      n / 7^3   3
      ...
      n / 7^k   k


      n / 7^k = 1  => 7^k = n

      log7(7^k) = log7(n)
      k * log7(7) = log7(n)
      k = log7(n)

      k = int(log7(n)) + 1  - Raspunsul exact
*/
#include <iostream>
#include <cmath>
using namespace std;

void B2(int n)
{
    for (int b = 31; b >= 0; --b)
        if (n & (1 << b)) // daca bitul b este setat (1)
            cout << 1;
        else
            cout << 0;
    cout << '\n';
}

int CountAllBits1(int n)
{
    int cnt {0};
    while (n)
    {
        cnt++;  // numar ultimul bit
        n /= 2; // "taiem" ultimul bit
    }
    return cnt;
}

int CountAllBits2(int n)
{
    int cnt {0};
    while (n)
    {
        cnt++;   // numar ultimul bit
        n >>= 1; // "taiem" ultimul bit  n = n >> 1;
    }
    return cnt;
}

int CountAllBits3(int n)
{
    int cnt {0};
    bool first_bit_one = false;
    for (int b = 31; b >= 0; --b)
        if (n & (1 << b)) // daca bitul b este 1
        {
            if (!first_bit_one)
                first_bit_one = true;
            cnt++;
        }
        else
            if (first_bit_one)
                cnt++;
    return cnt;
}

int CountAllBits4(int n)
{
   return (int)log2(n) + 1;
}


int main()
{
    int n;
    cin >> n;
    B2(n);
    cout << CountAllBits1(n) << '\n';
    cout << CountAllBits2(n) << '\n';
    cout << CountAllBits3(n) << '\n';
    cout << CountAllBits4(n) << '\n';

 //   cout << (int)log10(n) + 1;
}


