/**
  Numarul bitilor de 1 ai unui numar natural

*/
#include <iostream>
#include <cmath>
using namespace std;

void B2(int n)
{
    for (int b = 31; b >= 0; --b)
        if (n & (1 << b)) // daca bitul b este setat (1)
            cout << 1;
        else
            cout << 0;
    cout << '\n';
}

int CountBitsUne1(int n)
{
    int cnt {0};
    while (n)
    {
        if (n % 2 == 1) // daca ultimul bit este 1
            cnt++;      // il numar
        n /= 2;         // "taiem" ultimul bit
    }
    return cnt;
}

int CountBitsUne2(int n)
{
    int cnt {0};
    while (n)
    {
        if (n & 1)  // daca ultimul bit este 1
            cnt++;  // il numar
        n >>= 1;    // "taiem" ultimul bit  n = n >> 1;
    }
    return cnt;
}

int CountBitsUne3(int n)
{
    int cnt {0};
    for (int b = 31; b >= 0; --b)
        if (n & (1 << b)) // daca bitul b este 1
            cnt++;
    return cnt;
}

// utilizam o functie a compilatorului gcc
int CountBitsUne4(int n)
{
   return __builtin_popcount(n);
}


int CountBitsUne5(int n)
{
    int cnt{0};
    while (n)
    {
        n -= n & -n; // ultimul bit 1 din n devine 0
        cnt++;
    }
    return cnt;
}

int CountBitsUne6(int n)
{
    int cnt = 0;
    while (n)
    {
        n = n & (n - 1);  // n &= n - 1;
        cnt++;
    }
    return cnt;
}

int main()
{
    int n;
    cin >> n;
    B2(n);
    cout << CountBitsUne1(n) << '\n';
    cout << CountBitsUne2(n) << '\n';
    cout << CountBitsUne3(n) << '\n';
    cout << CountBitsUne4(n) << '\n';
    cout << CountBitsUne5(n) << '\n';
    cout << CountBitsUne6(n) << '\n';

}


