/**
   Reprezentare numerelor intregi negative in memoria RAM

   Fie un numar natural n.
   Pentru a obtine reprezentarea in memorie a lui -n:

   1. Se invereaza toti bitii lui n
   2. Se adauga 1 la rezultat

   -n = ~n + 1
*/
#include <iostream>
using namespace std;

void B2(int n)
{
    for (int b = 31; b >= 0; --b)
        if (n & (1 << b)) // daca bitul b este setat (1)
            cout << 1;
        else
            cout << 0;
    cout << '\n';
}

int main()
{
    int n;
    cin >> n;
    cout << "n      = "; B2(n);
    cout << "~n     = "; B2(~n);
    cout << "~n + 1 = "; B2(~n + 1);
    cout << "-n     = "; B2(-n);
}


