#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

using VB  = vector<bool>;
using VI  = vector<int>;
using VVI = vector<VI>;

const int MOD = 1000003;
VVI comb;  // combinari
int N = 30;
VB v;   // vizitat
VI c;   // componenta curenta
VI first  =  {11, 2, 7, 15, 22, 3, 1, 20, 3, 17, 2, 17, 19, 2, 3},
   second = {1, 5, 3, 3, 23, 29, 13, 25, 5, 1, 6, 3, 1, 3, 1};


int CountOrders();
int Count();
void Dfs(int x);

int main()
{
    cout << CountOrders();
}

int CountOrders()
{
    comb = VVI(N + 1, VI(N + 1));
    /// combinari
    for (int i = 0; i <= N; ++i)
    {
       comb[i][0] = comb[i][i] = 1;
        for (int j = 1; j < i; ++j)
            comb[i][j] = (comb[i - 1][j - 1] + comb[i - 1][j]) % MOD;
    }

    v = VB(N);
    int rez = 1;
    int total = N;  // nr de pozitii finale neocupate la momentul curent

    for (int i = 0; i < N; ++i)
    {
        if (v[i]) continue;
        c = VI();
        Dfs(i);
        rez = ((1LL * rez * Count()) % MOD * comb[total][c.size()]) % MOD;
        total -= c.size();
    }

    return rez;
}

// parcurge toate nodurile din componenta curenta
void Dfs(int x)
{
    if (v[x]) return;
    v[x] = true;
    c.push_back(x);

    for (size_t i = 0; i < first.size(); ++i)
        if (first[i] == x)
            Dfs(second[i]);
        else if (second[i] == x)
            Dfs(first[i]);
}

// returneaza numarul de posibilitati de a organiza componenta tare-conexa curenta
int Count()
{
    int n = c.size();   // dimensiunea componentei curente
    VI before = VI(n);  // un sir de masti de biti

    for (size_t i = 0; i < first.size(); ++i)
    {
        auto it1 = find(c.begin(), c.end(), first[i]);
        if (it1 != c.end())                                  // daca concurentul i este in componenta curenta si se claseaza inaintea altcuiva 
        {
            auto it2 = find(c.begin(), c.end(), second[i]);  // atunci si concurentul invins de i este in componenta curenta c
            int a = it1 - c.begin();  // poz lui first[i] in componenta curenta
            int b = it2 - c.begin();  // poz lui second[i] in componenta curenta
            before[b] |= (1 << a);    // in masca b plasez cate un bit pt fiecare predecesor direct (invingator) al lui second[i] (toti care-l intrec pe second[i])
        }
    }

    VI nr = VI(1 << n);
    nr[0] = 1;
    for (int i = 1; i < (1 << n); ++i)  // pt fiecare submultime i de concurenti din componenta curenta
        for (int j = 0; j < n; ++j)     
            /// daca j este in masca si toti predecesorii sai directi se gasesc in masca
            if (((i >> j) & 1) != 0 && ((i & before[j]) == before[j]))
            {
                nr[i] += nr[i ^ (1 << j)];
                if (nr[i] >= MOD)
                    nr[i] -= MOD;
            }

    return nr[(1 << n) - 1]; 
}




