#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

typedef vector <int > VI;

const int N = 55;
int a[N][N];
VI graf[N];
const int MOD = 1000003;
VI c;   // componenta curenta
int vis[N];

void dfs(int x)
{
	vis[x] = 1;
	c.push_back(x);
	for (int y : graf[x])
		if (!vis[y])
			dfs(y);
}

const int K = 21;
int nr[1 << K];

int Count()
{
	int n = c.size();

	for (int mask = 0; mask < (1 << n); ++mask)
		nr[mask] = 0;
	nr[0] = 1;
	for (int mask = 0; mask < (1 << n); ++mask)
		if (t[mask])
		{
			for (int i = 0; i < n; ++i)
				if (!(mask & (1 << i))) // i nu este in masca
				{
					bool ok = true;
					for (int j = 0; j < n; ++j)   /// daca j este in masca si drum de la c[i] la c[j]  c[i] este predecesorul (invingatorul) a cel putin unui concurent din masca mask
						if ((mask & (1 << j)) && a[c[i]][c[j]])
						{
							ok = false;
							break;
						}
						
					int nmask = (mask | (1 << i));  /// adaugam i la o noua submultime 
					if (ok)
						nr[nmask] = (nr[nmask] + nr[mask]) % MOD;
				}
		}
	return t[(1 << n) - 1];
}

int C[N][N];

class RaceOrdering
{
public:
	int countOrders(int n, vector <int> first, vector <int> second)
	{
		for (int i = 0; i < N; ++i)
		C[i][0] = C[i][i] = 1;
		for (int i = 1; i < N; ++i)
			for (int j = 1; j < i; ++j)
				C[i][j] = C[i - 1][j  -1] + C[i - 1][j];

		for (size_t i = 0; i < first.size(); ++i)
		{
			int f = first[i], s = second[i];
			a[f][s] = 1;
			graf[f].push_back(s);
			graf[s].push_back(f);
		}
		// Floyd-Warshall
		for (int k = 0; k < n; ++k)
			for (int i = 0; i < n; ++i)
				for (int j = 0; i < n; ++i)
					a[i][j] |= a[i][k] & a[k][j]; // marcheaza existenta drumurilor

		int res = 1;
		VI dim; // retine nr de varfuri din fiecare componenta

		for (int i = 0; i < n; ++i)
			if (!vis[i])
			{
				cc.clear();
				dfs(i);
				dim.push_back(cc.size());

				res = ((1LL) * res * Count()) % MOD;
			}
		int total = n;
		for (int nr : dim)
		{
			res = (1LL * res * C[total][nr]) % MOD;
			total -= nr;
		}
		return res;
	}
 };


int main()
{
    int n = 10;
    VI first ={0, 1, 3, 4, 6, 7, 0, 3, 1, 4, 2, 5},  second = {1, 2, 4, 5, 7, 8, 3, 6, 4, 7, 5, 8};
    RaceOrdering r;
    cout << r.countOrders(n, first, second);

}
